'Source of Batloader by Jonemaan. My style of programming

q1 = 65536: q2 = 256: OPEN "C:\sfcoll.lst" FOR INPUT AS #1: INPUT #1, i: CLOSE #1
SCREEN 13: PALETTE 26, q1 * 20 + q2 * 20 + 20
CLS : COLOR 26: IF i = 1 THEN COLOR 0
PRINT "Initializing": PRINT
DIM coldesccol(4), coldescdesc$(4)
DIM namename$(1000), namefile$(1000), namecol(1000)
DIM getunder(1980), getcur(457): DEF SEG = &HA000

'get lines from description file
PRINT "Getting lines": OPEN "sfcoll.dsc" FOR INPUT AS #1
DO
INPUT #1, a$
IF a$ = "#LINES" THEN GOTO linesin
LOOP
linesin:
INPUT #1, a$: a$ = LEFT$(a$, 17): title$ = "Street Fighters Arcade " + a$
INPUT #1, a$: INPUT #1, B$: CLOSE #1
a$ = LEFT$(a$, 13): B$ = LEFT$(B$, 6)
cmd$ = a$ + " (TAB=" + B$ + ")"

'get default colors from description file
PRINT "Getting default colors": OPEN "sfcoll.dsc" FOR INPUT AS #1
DO
INPUT #1, a$
IF a$ = "#DEFCOLORS" THEN GOTO defcolin
LOOP
defcolin:
INPUT #1, red0, green0, blue0
INPUT #1, red1, green1, blue1
r = red0: g = green0: B = blue0: rr = 0: bb = 0: gg = 0
FOR i = 6 TO 20
r = r + ((red1 - red0) / 14)
g = g + ((green1 - green0) / 14)
B = B + ((blue1 - blue0) / 14)
rr = FIX(r)
bb = FIX(B)
gg = FIX(g)
IF rr > 63 THEN rr = 63
IF rr < 0 THEN rr = 0
IF gg > 63 THEN gg = 63
IF gg < 0 THEN gg = 0
IF bb > 63 THEN bb = 63
IF bb < 0 THEN bb = 0
PALETTE i, q1 * bb + q2 * gg + rr
NEXT
INPUT #1, r, g, B: PALETTE 21, q1 * B + q2 * g + r
INPUT #1, r, g, B: PALETTE 22, q1 * B + q2 * g + r
INPUT #1, r, g, B: PALETTE 23, q1 * B + q2 * g + r
INPUT #1, r, g, B: PALETTE 24, q1 * B + q2 * g + r
INPUT #1, r, g, B: PALETTE 25, q1 * B + q2 * g + r
CLOSE #1

'get colors from description file
PRINT "Getting colors": OPEN "sfcoll.dsc" FOR INPUT AS #1
DO
INPUT #1, a$
IF a$ = "#COLORS" THEN GOTO colorin
LOOP
colorin:
DO
INPUT #1, col, red, green, blue
IF col = 999 THEN GOTO colorend
PALETTE col, q1 * blue + q2 * green + red
LOOP
colorend:
CLOSE #1

'get color descriptions from description file
PRINT "Getting color descriptions": OPEN "sfcoll.dsc" FOR INPUT AS #1
DO
INPUT #1, a$
IF a$ = "#DESC" THEN GOTO descin
LOOP
descin:
i = 0
DO
INPUT #1, a$
i = i + 1
IF a$ = "#ENDDESC" THEN GOTO descend
a$ = LEFT$(a$, 25): coldescdesc$(i) = a$: INPUT #1, coldesccol(i)
LOOP
descend:
CLOSE #1: numberofdesc = i - 1

'get names from description file
PRINT "Getting names": OPEN "sfcoll.dsc" FOR INPUT AS #1
DO
INPUT #1, a$
IF a$ = "#NAMES" THEN GOTO namin
LOOP
namin:
i = 0
DO
i = i + 1: INPUT #1, namename$(i)
IF namename$(i) = "#ENDNAMES" THEN namename$(i) = "": GOTO nameend
namename$(i) = namename$(i) + "                          ": namename$(i) = LEFT$(namename$(i), 25)
INPUT #1, namefile$(i): INPUT #1, namecol(i)
LOOP
nameend:
CLOSE #1: numberofnames = i - 1

'make main screen
CLS : COLOR 21: PALETTE 0, q1 * blue0 + q2 * green0 + red0
LOCATE 1, 20 - (LEN(title$) / 2): PRINT title$
c = 5
FOR i = 158 TO 145 STEP -1
c = c + 1
LINE (0, i)-(319, i), c
NEXT: c = 5
FOR i = 8 TO 21
c = c + 1
LINE (0, i)-(319, i), c
NEXT
LINE (0, 22)-(319, 144), 20, BF
LINE (7, 23)-(224, 143), 0, BF
LINE (6, 22)-(225, 144), 22, B
IF numberofdesc = 0 THEN GOTO verder1inmaakmain
af = numberofdesc * 8
LINE (6, 158)-(225, af + 161), 22, B
FOR i = 1 TO numberofdesc
LOCATE 20 + i, 2
COLOR coldesccol(i)
PRINT " "; : COLOR 21: PRINT coldescdesc$(i);
NEXT
LINE (8, 160)-(17, 160), 0
LINE (8, 168)-(17, 167), 0, BF
LINE (8, 176)-(17, 175), 0, BF
LINE (8, 184)-(17, 183), 0, BF
LINE (8, 192)-(17, 191), 0, BF
verder1inmaakmain:
LOCATE 4, 1: COLOR 21
nmax = numberofnames
IF nmax > 14 THEN FOR i = 1 TO 15: COLOR namecol(i): LOCATE , 2: PRINT "  " + namename$(i): NEXT
IF nmax < 15 THEN FOR i = 1 TO nmax: COLOR namecol(i): LOCATE , 2: PRINT "  " + namename$(i): NEXT
GET (6, 158)-(225, 193), getunder
GOSUB keyleeg
n = 1: lox = 4
GET (22, 23)-(224, 31), getcur
LINE (22, 23)-(224, 31), 23, B
LINE (21, 22)-(21, 144), 22
LINE (6, 34)-(21, 34), 22
LINE (6, 132)-(21, 132), 22
LINE (238, 118)-(312, 144), 22, B
PAINT (239, 119), 0, 22
barstep = 96 / nmax: barmin = 35: barmax = 131 - barstep
LOCATE 17, 31: PRINT "         ": cmdmakker$ = ""
GOSUB maakpijlen
OPEN "C:\sfcoll.lst" FOR INPUT AS #1
INPUT #1, a: IF a = 0 THEN CLOSE #1: GOTO main
IF a = 1 THEN PUT (22, (lox * 8) - 9), getcur, PSET
INPUT #1, n$: INPUT #1, lox: INPUT #1, n: CLOSE #1
IF nmax > 14 THEN o = 3: FOR i = n - (15 - 18 + lox) + 1 TO n + (18 - lox): COLOR namecol(i): o = o + 1: LOCATE o, 4: PRINT namename$(i): NEXT: GET (22, (lox * 8) - 9)-(224, (lox * 8) - 1), getcur: LINE (22, (lox * 8) - 9)-(224, (lox * 8) - 1), 23,  _
B: GOSUB maakpijlen: GOTO main
IF nmax < 15 THEN FOR i = 1 TO nmax: COLOR namecol(i): LOCATE i + 3, 4: PRINT namename$(i): NEXT: GET (22, (lox * 8) - 9)-(224, (lox * 8) - 1), getcur: LINE (22, (lox * 8) - 9)-(224, (lox * 8) - 1), 23, B: GOSUB maakpijlen: GOTO main

main: 'mainloop
a$ = INKEY$
IF a$ = CHR$(27) THEN GOSUB fadeout: COLOR 7: SCREEN 0: WIDTH 80: CLS : PRINT "Batloader by Jonemaan June 1999. Have a nice DOS! :)": PRINT : OPEN "C:\sfcoll.lst" FOR OUTPUT AS #1: PRINT #1, 0: CLOSE #1: END
IF a$ = CHR$(9) THEN GOTO cmdkijk
IF a$ = CHR$(0) + CHR$(80) THEN GOTO curdown
IF a$ = CHR$(0) + CHR$(72) THEN GOTO curup
IF a$ = CHR$(0) + "Q" THEN GOTO pagedown
IF a$ = CHR$(0) + "I" THEN GOTO pageup
IF a$ = CHR$(0) + "G" THEN GOTO schome
IF a$ = CHR$(0) + "O" THEN GOTO scend
IF a$ < CHR$(123) AND a$ > CHR$(96) THEN GOTO letter
IF a$ > CHR$(47) AND a$ < CHR$(58) THEN GOTO letter
IF a$ > CHR$(64) AND a$ < CHR$(91) THEN GOTO letter
IF a$ = CHR$(13) THEN GOTO runbat
GOTO main

curup: 'cursor up
IF n = 1 THEN GOTO main
PUT (22, (lox * 8) - 9), getcur, PSET
n = n - 1: lox = lox - 1
IF lox = 3 THEN lox = 4: FOR i = 4 TO 18: LOCATE i, 4: COLOR namecol(n + i - 4): PRINT namename$(n + i - 4): NEXT
GET (22, (lox * 8) - 9)-(224, (lox * 8) - 1), getcur
LINE (22, (lox * 8) - 9)-(224, (lox * 8) - 1), 23, B
GOSUB maakpijlen
GOTO main

curdown: 'cursor down
IF n = nmax THEN GOTO main
PUT (22, (lox * 8) - 9), getcur, PSET
n = n + 1: lox = lox + 1
IF lox = 19 THEN lox = 18: FOR i = 4 TO 18: LOCATE i, 4: COLOR namecol(n + i - 18): PRINT namename$(n + i - 18): NEXT
GET (22, (lox * 8) - 9)-(224, (lox * 8) - 1), getcur
LINE (22, (lox * 8) - 9)-(224, (lox * 8) - 1), 23, B
GOSUB maakpijlen
GOTO main

pageup: 'page up(15)
IF n = 1 THEN GOTO main
PUT (22, (lox * 8) - 9), getcur, PSET
IF nmax < 16 THEN n = 1: lox = 4: GOTO pu1
FOR i = 1 TO 15
n = n - 1: lox = lox - 1
IF lox = 3 THEN lox = 4
IF n < 1 THEN n = 1
NEXT
FOR i = 4 TO 18: LOCATE i, 4: COLOR namecol(n + i - 4): PRINT namename$(n + i - 4): NEXT
pu1: GET (22, (lox * 8) - 9)-(224, (lox * 8) - 1), getcur
LINE (22, (lox * 8) - 9)-(224, (lox * 8) - 1), 23, B
GOSUB maakpijlen
GOTO main

pagedown: 'page down(15)
IF n = nmax THEN GOTO main
PUT (22, (lox * 8) - 9), getcur, PSET
IF nmax < 16 THEN n = nmax: lox = nmax + 3: GOTO pd1
FOR i = 1 TO 15
n = n + 1: lox = lox + 1
IF lox = 19 THEN lox = 18
IF n > nmax THEN n = nmax
NEXT
FOR i = 4 TO 18: LOCATE i, 4: COLOR namecol(n + i - 18): PRINT namename$(n + i - 18): NEXT
pd1: GET (22, (lox * 8) - 9)-(224, (lox * 8) - 1), getcur
LINE (22, (lox * 8) - 9)-(224, (lox * 8) - 1), 23, B
GOSUB maakpijlen
GOTO main

schome: 'cursor all up
IF n = 1 THEN GOTO main
n = 1: PUT (22, (lox * 8) - 9), getcur, PSET: lox = 4
IF nmax < 16 THEN GOTO ho1
FOR i = 4 TO 18: LOCATE i, 4: COLOR namecol(n + i - 4): PRINT namename$(n + i - 4): NEXT
ho1: GET (22, (lox * 8) - 9)-(224, (lox * 8) - 1), getcur
LINE (22, (lox * 8) - 9)-(224, (lox * 8) - 1), 23, B
GOSUB maakpijlen
GOTO main

scend: 'cursor all down
IF n = nmax THEN GOTO main
n = nmax: PUT (22, (lox * 8) - 9), getcur, PSET: lox = 18
IF nmax < 16 THEN lox = nmax + 3: GOTO en1
FOR i = 4 TO 18: LOCATE i, 4: COLOR namecol(n + i - 18): PRINT namename$(n + i - 18): NEXT
en1: GET (22, (lox * 8) - 9)-(224, (lox * 8) - 1), getcur
LINE (22, (lox * 8) - 9)-(224, (lox * 8) - 1), 23, B
GOSUB maakpijlen
GOTO main

letter: 'als op letter gedrukt wordt naar letter
IF ASC(a$) > 96 AND ASC(a$) < 123 THEN a$ = CHR$(ASC(a$) - 32)
FOR i = 1 TO nmax: n$ = LEFT$(namename$(i), 1)
IF ASC(n$) > 96 AND ASC(n$) < 123 THEN n$ = CHR$(ASC(n$) - 32)
IF n$ = a$ THEN num = i: GOTO lgev
NEXT
GOTO main
lgev: 'letter gevonden in rij namen
IF num = n THEN GOTO main
PUT (22, (lox * 8) - 9), getcur, PSET
IF num < n AND lox - 3 - ABS(num - n) > 0 THEN GOSUB zelfdeblz
IF num > n AND lox - 3 + ABS(num - n) < 16 THEN GOSUB zelfdeblz
IF num > n AND lox - 3 + ABS(num - n) > 15 THEN GOSUB blzonder
IF num < n AND lox - 3 - ABS(num - n) < 1 THEN GOSUB blzboven
GET (22, (lox * 8) - 9)-(224, (lox * 8) - 1), getcur
LINE (22, (lox * 8) - 9)-(224, (lox * 8) - 1), 23, B
GOSUB maakpijlen
GOTO main
zelfdeblz: 'letter op zelfde blz
lox = lox + num - n: n = num
RETURN
blzonder: 'letter op blz eronder
lox = 18: n = num
FOR i = 4 TO 18: LOCATE i, 4: COLOR namecol(n + i - 18): PRINT namename$(n + i - 18): NEXT
RETURN
blzboven: 'letter op blz erboven
lox = 4: n = num
FOR i = 4 TO 18: LOCATE i, 4: COLOR namecol(n + i - 4): PRINT namename$(n + i - 4): NEXT
RETURN

runbat: 'run file
IF namefile$(n) = "<>" THEN GOTO main
1 GOSUB fadeout: COLOR 7: SCREEN 0: WIDTH 80: CLS
OPEN "C:\sfcoll.lst" FOR OUTPUT AS #1
PRINT #1, 1
PRINT #1, namefile$(n) + cmdmakker$
PRINT #1, lox: PRINT #1, n
CLOSE #1
RUN "sfcoll2"

cmdkijk: 'CMDLine invoeren
GOSUB keyleeg: COLOR 21
LINE (7, 159)-(224, af + 160), 0, BF
IF af < 16 THEN LINE (6, 158)-(225, 177), 22, B: LINE (7, 159)-(224, 176), 0, BF
LOCATE 21, 2: PRINT cmd$
txt$ = "": xbeg = 2: LOCATE 22, 2: PRINT ""
txtinp: a$ = INPUT$(1)
IF a$ = CHR$(8) AND LEN(txt$) > 0 THEN xbeg = xbeg - 1: LOCATE 22, xbeg: PRINT " ": txt$ = MID$(txt$, 1, LEN(txt$) - 1)
IF a$ = CHR$(13) THEN txt$ = RTRIM$(txt$): txt$ = LTRIM$(txt$): GOTO txtklaar
IF a$ = CHR$(9) THEN GOTO cmdklaar
IF a$ > CHR$(31) AND a$ < CHR$(200) AND LEN(txt$) < 25 THEN LOCATE 22, xbeg: PRINT a$: xbeg = xbeg + 1: txt$ = txt$ + a$
LOCATE 22, xbeg: PRINT " "
GOTO txtinp
txtklaar:
cmdmakker$ = " " + txt$
cmdklaar:
PUT (6, 158), getunder, PSET
GOTO main

keyleeg: 'maak keyboardbuffer leeg
evenkijken: no$ = INKEY$: IF no$ <> "" THEN GOTO evenkijken
RETURN

fadeout: 'fade screen out
FOR doen = 1 TO 64
FOR c1 = 1 TO 100
GOSUB readrgb
r1 = r1 - 1: g1 = g1 - 1: b1 = b1 - 1
IF r1 = -1 THEN r1 = 0
IF g1 = -1 THEN g1 = 0
IF b1 = -1 THEN b1 = 0
GOSUB writergb
NEXT: NEXT: RETURN

readrgb: 'read rgb values from color c1
OUT &H3C7, c1
r1 = INP(&H3C9)
g1 = INP(&H3C9)
b1 = INP(&H3C9)
RETURN

writergb: 'write rgb values to color c1
OUT &H3C8, c1
OUT &H3C9, r1
OUT &H3C9, g1
OUT &H3C9, b1
RETURN

maakpijlen: 'niet alleen pijlen, maar ook bar en info.
GOSUB wegpijlen
IF n - lox + 4 < nmax - 14 THEN GOSUB pijlonder
IF n - lox + 4 > 1 THEN GOSUB pijlboven
LINE (7, barmin + (n * barstep) - barstep)-(20, barmin + (n * barstep)), 25, BF
COLOR 21: LOCATE 18, 31: PRINT "         ": LOCATE 16, 31: PRINT "         "
LOCATE 16, 31
IF namefile$(n) = "<>" THEN nf$ = "": PRINT nf$: GOTO maakp2
IF LEN(namefile$(n)) > 8 THEN nf$ = LEFT$(namefile$(n), 7) + "..": PRINT nf$ ELSE PRINT namefile$(n)
maakp2: nmax$ = STR$(nmax): nmax$ = LTRIM$(nmax$): nmax$ = nmax$ + "    ": nmax$ = LEFT$(nmax$, 4)
n$ = STR$(n): n$ = LTRIM$(n$): n$ = n$ + "    ": n$ = LEFT$(n$, 4)
LOCATE 18, 31: PRINT n$ + "/" + nmax$
RETURN
wegpijlen: 'pijlen wegvegen & bar wegvegen
'bar
LINE (7, 35)-(20, 131), 0, BF
'boven
LINE (14, 24)-(10, 28), 0
LINE (14, 24)-(18, 28), 0
LINE (14, 27)-(10, 31), 0
LINE (14, 27)-(18, 31), 0
'onder
LINE (14, 142)-(10, 138), 0
LINE (14, 142)-(18, 138), 0
LINE (14, 139)-(10, 135), 0
LINE (14, 139)-(18, 135), 0
RETURN
pijlboven: 'maak pijl boven
LINE (14, 24)-(10, 28), 24
LINE (14, 24)-(18, 28), 24
LINE (14, 27)-(10, 31), 24
LINE (14, 27)-(18, 31), 24
RETURN
pijlonder: 'maak pijl onder
LINE (14, 142)-(10, 138), 24
LINE (14, 142)-(18, 138), 24
LINE (14, 139)-(10, 135), 24
LINE (14, 139)-(18, 135), 24
RETURN

